/*
Copyright 2019 HAProxy Technologies

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package tests

import (
	configparser "github.com/haproxytech/config-parser/v2"
	"github.com/haproxytech/config-parser/v2/common"
)

func ProcessLine(line string, parser configparser.ParserInterface) error {
	parts, comment := common.StringSplitWithCommentIgnoreEmpty(line, ' ', '\t')
	parser.Init()
	_, err := parser.Parse("  "+line, parts, []string{}, comment)
	return err
}
